/* Public domain. */

#include <nemo/stdint.h>
#include <nemo/unixtypes.h>

#include "cdb.h"

#include <sys/stat.h>
#include <sys/mman.h>

void cdb_free(register struct cdb *c)
{
  if (c->map) {
    munmap(c->map, c->size);
    c->map = 0;
    c->size = 0;
  }
}

void cdb_init(register struct cdb *c, int fd)
{
  struct stat st;
  void *x;

  cdb_free(c);
  cdb_findstart(c);
  c->fd = fd;
  if (fstat(fd, &st) == 0) {
    if (st.st_size <= (signed)0xffffffff) {
      x = mmap(0, (size_t)st.st_size, PROT_READ, MAP_SHARED, fd, 0);
      if (x != MAP_FAILED) {
        c->size = (uint32_t)st.st_size;
        c->map = x;
      }
    }
  }
}
