/* Public domain. */

#ifndef NEMO_CDB_MAKE_H
#define NEMO_CDB_MAKE_H

#include <nemo/stdint.h>
#include <nemo/stralloc.h>
#include <nemo/djbio.h>

#define CDB_HPLIST 1000

struct cdb_hp {
  uint32_t h;
  uint32_t p;
};

struct cdb_hplist {
  struct cdb_hp hp[CDB_HPLIST];
  struct cdb_hplist *next;
  int num;
};

struct cdb_make {
  byte_t bspace[8192];
  byte_t final[2048];
  uint32_t count[256];
  uint32_t start[256];
  struct cdb_hplist *head;
  struct cdb_hp *split;		/* includes space for hash */
  struct cdb_hp *hash;
  uint32_t num_entries;
  uint32_t pos;
  int fd;
  djbio io;
};

int	cdb_make_start(struct cdb_make *c, int fd);
int	cdb_make_addbegin(struct cdb_make *c, unsigned int keylen, unsigned int datalen);
int	cdb_make_addend(struct cdb_make *c, unsigned int keylen, unsigned int datalen, uint32_t h);
int	cdb_make_add(struct cdb_make *c, const void *key, unsigned int keylen, const void *data, unsigned int datalen);
int	cdb_make_finish(struct cdb_make *c);

#endif
