/* Public domain. */

#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/unix.h>
#include <nemo/error.h>
#include <nemo/seek.h>
#include <nemo/byte.h>

#include "cdb.h"

int cdb_read(register struct cdb *c, void *d, unsigned int len, uint32_t pos)
{
  register ssize_t read_size;
  register byte_t *buf;

  buf = d;
  if (c->map) {
    if ((pos > c->size) || (c->size - pos < len)) goto FORMAT;
    byte_copy(buf, len, c->map + pos);
  }
  else {
    if (seek_set(c->fd, (off_t)pos) < 0) return -1;
    while (len > 0) {
      do {
        read_size = read(c->fd, buf, len);
      } while ((read_size < 0) && (errno == error_intr));
      if (read_size < 0) return -1;
      if (!read_size) goto FORMAT;
      buf += read_size;
      len -= (unsigned int)read_size;
    }
  }
  return 0;

FORMAT:
  errno = error_proto;
  return -1;
}
