#include <nemo/scan.h>
#include <nemo/strerr.h>
#include <nemo/exit.h>
#include <nemo/stdint.h>
#include <nemo/uint32.h>

#include "cdb_make.h"

static const char FATAL[] = "testzero: fatal: ";

static void die_write(void)
{
  strerr_die2sys(111, FATAL, "unable to write");
}

static byte_t key[4];
static byte_t data[65536];
static struct cdb_make c;

int main(int argc, char **argv)
{
  unsigned long loop;
  if (argc < 2) _exit(0);
  if (!*argv) _exit(0);
  if (!*++argv) _exit(0);
  scan_ulong(*argv, &loop);
  if (cdb_make_start(&c, 1) < 0) die_write();
  while (loop) {
    uint32_pack((uint32_t)(--loop), key);
    if (cdb_make_add(&c, key, 4, data, sizeof(data)) < 0) die_write();
  }
  if (cdb_make_finish(&c) < 0) die_write();
  _exit(0);
}
